<?php
namespace Paymentpage\includes\API;

/**
 * Edpoints API
 * TODO: When the api start grows it will be necesary to split code into their respective endpoints.
 * ie: SetuP API, EditorAPI..
 */
class EndpointsApi
{

    private static $Setup_Controller;

    private static $Mailchimp_Controller;

    private static $Gateway_Controller;

    private static $Dependencies;

    private static $Templates;

    private static $Stripe;

    public function __construct()
    {
        header("Access-Control-Allow-Origin: *");
        self::init_routes();
        self::$Setup_Controller = new \Paymentpage\includes\controllers\SetupController();
        self::$Mailchimp_Controller = new \Paymentpage\includes\controllers\MailchimpController();
        self::$Gateway_Controller = new \Paymentpage\includes\controllers\PaymentsGatewayControllers();
        self::$Dependencies = new \Paymentpage\includes\controllers\DependenciesController();
        self::$Templates = new \Paymentpage\includes\controllers\TemplateController();
        self::$Stripe = new \Paymentpage\includes\controllers\StripeController();
    }

    private static function init_routes()
    {
        register_rest_route('payment-page/v1', '/start_setup', array(
            'methods' => \WP_REST_Server::READABLE,
            'callback' => array(
                __CLASS__,
                'handle_start_setup'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/mailchimp/add_or_update_member', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_add_or_update_member'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/install_dependency', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_install_dependency'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/activate_dependency', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_activate_dependency'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/is_dependency_installed', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_is_dependency_installed'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/is_dependency_activated', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_is_dependency_activated'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/save_setup_data', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_save_setup_data'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/move_to_step', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_move_to_step'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/product_image_upload', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_upload_image_product'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/templates', array(
            'methods' => 'GET',
            'callback' => array(
                __CLASS__,
                'handle_get_templates'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));
        
        register_rest_route('payment-page/v1', '/create_subscription', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_create_subscription'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/create_stripe_product', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_create_stripe_product'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/get_or_create_stripe_customer', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_get_or_create_stripe_customer'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/update_or_create_payment_intent', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_update_or_create_payment_intent'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/set_stripe_mode', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_set_stripe_mode'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));        

        register_rest_route('payment-page/v1', '/get_stripe_mode', array(
            'methods' => 'GET',
            'callback' => array(
                __CLASS__,
                'handle_get_stripe_mode'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));      

        register_rest_route('payment-page/v1', '/disconnect_account', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_disconnect_account'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));

        register_rest_route('payment-page/v1', '/delete_plugin_data', array(
            'methods' => 'POST',
            'callback' => array(
                __CLASS__,
                'handle_delete_plugin_data'
            ),
            'permission_callback' => array(
                __CLASS__,
                'callback_evalution'
            )
        ));
        
        

    }

    public static function callback_evalution()
    {
        return true;
    }


    public static function handle_delete_plugin_data(){
        // Delete currencies
        echo self::$Stripe::delete_stripe_data();

    }

    public static function handle_disconnect_account($request){
        $body = $request->get_json_params();
        $mode = $body['mode'];        
        echo  self::$Stripe::disconnect_account($mode);
    }

    
    public static function handle_get_or_create_stripe_customer($request)
    {
        $body = $request->get_json_params();
        $stripe_mode = self::$Stripe::get_stripe_mode();
        $is_live = $stripe_mode === 'live' ? 1 : 0;

        $data = array(
            'live' => $is_live,
            "account_id" => sanitize_text_field( $body['account_id'] ),
            "customer_email" => $body['customer_email'],
        );

        echo self::$Stripe::create_stripe_customer($data);
    }
    
    public static function handle_create_stripe_product($request)
    {
        $body = $request->get_json_params();
        $stripe_mode = self::$Stripe::get_stripe_mode();
        $is_live = $stripe_mode === 'live' ? 1 : 0;

        $data = array(
            'live' => $is_live,
            "account_id" => sanitize_text_field( $body['account_id'] ),
            "product" => $body['product'],
        );

        echo self::$Stripe::create_stripe_product($data);
    }

    
    public static function handle_create_subscription($request)
    {
        $body = $request->get_json_params();
        $stripe_mode = self::$Stripe::get_stripe_mode();
        $is_live = $stripe_mode === 'live' ? 1 : 0;
        
        $data = array(
            "customer_id" => $body['customerId'],
            "payment_method_id"=> $body['paymentMethodId'],
            "price_id" => $body['priceId'],
            "product_id" => $body['productId'],
            "account_id" => sanitize_text_field( $body['account_id'] ),
            'live' => $is_live,
        );
        echo self::$Stripe::create_subscription($data);
    }

    public static function handle_update_or_create_payment_intent($request)
    {
        $body = $request->get_json_params();
        error_log('$body:');
        error_log(print_r($body, true));
        $stripe_mode = self::$Stripe::get_stripe_mode();
        
        if( !isset($body['amount'])  || !is_numeric($body['amount'])  ) return false;
        if( !isset($body['currency'])  || empty($body['currency'])   ) return false;
        if( !isset($body['paymentoption'])  || empty($body['paymentoption'])   ) return false;
        if( !isset($body['account_id'])  || empty($body['account_id'])   ) return false;

        $amount = (int) $body['amount'];
        $currency = sanitize_text_field( $body['currency'] );
        $paymentoption = sanitize_text_field( $body['paymentoption'] );
        $account_id = sanitize_text_field( $body['account_id'] );
        $customer_id = !empty($body['customer_id']) ? sanitize_email( $body['customer_id'] ) : 0;         
        $payment_intent_id = ( isset($body['payment_intent_id']) ? $body['payment_intent_id'] : false );
        $is_live = $stripe_mode === 'live' ? 1 : 0;


        $product = array(
            'amount' => $amount,
            'currency' => $currency,
        );

        $payment_intent = array(
            'is_live' => $is_live,
            'account_id' => $account_id,
            'product'=> $product,
            'payment_intent_id' => $payment_intent_id,
            'customer_id'=>$customer_id,
        );
    
        echo self::$Stripe::create_payment_intent($payment_intent);
    }

    public static function handle_move_to_step($request)
    {
        $body = $request->get_json_params();
        if (isset($body['step']) && ! empty($body['step']) && ! intval($body['step']))
            return false;

        $step = absint($body['step']);

        if ( $step  > -1 ) {
            return self::$Setup_Controller::set_setup_step($step);
        }
    }

    public static function handle_get_templates()
    {
        return self::$Templates->get_templates();
    }

    public static function handle_is_dependency_installed($request)
    {
        $body = $request->get_json_params();
        if (! isset($body['plugin']) || empty($body['plugin'])) return false;
        $plugin_slug = sanitize_text_field($body['plugin']);

        return self::$Dependencies::is_plugin_installed($plugin_slug);
    }

    public static function handle_is_dependency_activated($request)
    {
        $body = $request->get_json_params();
        if (! isset($body['plugin']) || empty($body['plugin']))
            return false;
        $plugin_slug = sanitize_text_field($body['plugin']);
        return self::$Dependencies::is_dependency_activated($plugin_slug);
    }

    public static function handle_install_dependency($request)
    {
        $body = $request->get_json_params();

        if (! isset($body['plugin']) || empty($body['plugin']))
            return false;
        $plugin_slug = sanitize_text_field($body['plugin']);    
        return self::$Dependencies::install_plugin( $plugin_slug, $request->get_header('X-WP-Nonce'));
    }

    public static function handle_activate_dependency($request)
    {
        $body = $request->get_json_params();
        if (! isset($body['plugin']) || empty($body['plugin']))
            return false;
        $plugin_slug = sanitize_text_field($body['plugin']);
        return self::$Dependencies::activate_dependency( $plugin_slug );
    }

    public static function handle_upload_image_product($request)
    {
        $data = $request;

        require_once (ABSPATH . "wp-admin" . '/includes/image.php');
        require_once (ABSPATH . "wp-admin" . '/includes/file.php');
        require_once (ABSPATH . "wp-admin" . '/includes/media.php');

        $imagetype = array(
            'bmp' => 'image/bmp',
            'gif' => 'image/gif',
            'jpe' => 'image/jpeg',
            'jpeg' => 'image/jpeg',
            'jpg' => 'image/jpeg',
            'png' => 'image/png',
            'tif' => 'image/tiff',
            'tiff' => 'image/tiff',
            'svg' => 'image/svg+xml'
        );

        $override = array(
            'mimes' => $imagetype,
            'test_form' => false
        );

        foreach ($_FILES as $file) {
            $upload_file = wp_handle_upload($file, $override);
            remove_filter('upload_dir', array(
                __CLASS__,
                'change_upload_dir'
            ));
            if (isset($upload['error'])) {
                return $upload['error'];
            } else {
                $uploaded_file_url = $upload_file['url'];
                $uploaded_file_name = basename($upload_file['url']);
            }
        }
        return array(
            'file_url' => $uploaded_file_url
        );
    }

    /**
     * This route should return all configuration data and stored previous setup information if exists.
     * TODO: return all payment gateways, now we only return Stripe configuration. All other
     * payment gateways are harcoded into the front end
     */
    public static function handle_start_setup()
    {
        return self::$Setup_Controller::start_setup();
    }

    public static function handle_add_or_update_member($request){
        $body = $request->get_json_params();        
        echo self::$Mailchimp_Controller::add_or_update_member($body);
        self::$Gateway_Controller::set_prefered_non_avaiable_gateways( $body['tag'] );

    }

    /*
     * @author:Victor Albala
     * @date:8/6/2020
     * @action:Store the information for each step
     * @return boolean
     *
     */
    public static function handle_save_setup_data($request)
    {
        $body = $request->get_json_params();

        if (! isset($body["step"]) || empty($body["step"]) || intval($body["step"]) <= 0) {
            return new WP_REST_Response(array(
                'error' => 'Step field is empty.'
            ), 400);
        }

        $step = absint( $body["step"]);

        /**
         * Step 1
         * Set payment gateway selected by user and save non available gateway prefered by the user.
         */
        if ($step === 1) {
            $prefered_non_avaiables_gateways = isset($body['prefered_non_avaiables_gateways']) && ! empty($body['prefered_non_avaiables_gateways']) ? (array) $body['prefered_non_avaiables_gateways'] : array();
            if ( count($prefered_non_avaiables_gateways) > 0 ) {
                $prefered_non_avaiables_gateways = array_map('sanitize_text_field', $prefered_non_avaiables_gateways );
                self::$Gateway_Controller::set_prefered_non_avaiable_gateways( $prefered_non_avaiables_gateways );
            }
            // TODO: On the step 1 user will be able to configure all the gateways available. If it's the user can continue to the next step
            // If he do click into the next button.
            // We cannot set wich current step is until the user clicked on that kinkd of butotn and send into the body the state
            // IMPORTANT! Actually we are only have support for Stripe gateway. To fowardng to the next step we need a webhook to save the stripe information and set the next step
            return true;
        }

        if ($step === 2) {
            $selected_methods = (array) $body['selectedMethods'];
            if (count($selected_methods) > 0) {
                foreach ($selected_methods as $gateway) {
                    $gateway_name = $gateway['name'];
                    $gateway_methods = $gateway['methods'];                    
                    self::$Gateway_Controller::set_methods_options_selected($gateway_name, $gateway_methods);
                    self::$Setup_Controller::set_setup_step(3);
                    return $selected_methods;
                }
            }
        }

        if ($step === 3) {
            if (isset($body['data']) && ! empty($body['data'])) {
                $data = $body['data'];
                
                $page_data = array();
                $product = $data['product'];
                
                if( $product['title'] === "") return;
                if( $product['description'] === "") return;
                $product_title = sanitize_text_field( $product['title'] );
                $product_description = sanitize_text_field( $product['description'] );
                $payment_type = sanitize_text_field($data['paymentType']);
                $subscription_required = rest_sanitize_boolean($data['subscription-required']);

                $frequency_options = $data['frecuency-option'];
                foreach( $frequency_options as &$frequency ){
                    rest_sanitize_boolean( $frequency );
                }

                $page_data = array(
                    'product' => array(
                        'title' => $product_title,
                        'description' => $product_description,
                        'image' => $product['image'],
                    ),
                    'paymentType' => $payment_type,
                    'subscription-required' => $subscription_required,
                    'frecuency-option' => $frequency_options
                );

                self::$Setup_Controller::save_first_payment_page_data($page_data);
                self::$Setup_Controller::set_setup_step(4);
                return $page_data;
            }
        }

        if ($step === 4) {
            if (isset($body['data']) && ! empty($body['data'])) {

                $data = $body['data'];
                $template_id = absint($data['template_id']);
                if( $template_id < 0 ) return;
                
                self::$Setup_Controller::save_template_selected($template_id);
                $draft_page_id = self::$Setup_Controller::create_draft_page($template_id);
                $template_builder = "elementor";
                $url = get_admin_url() . 'post.php?post=' . $draft_page_id . '&action=' . $template_builder;
                return esc_url_raw($url);
            }
        }

        if ($step === 5) {
            if (isset($body['data']) && ! empty($body['data'])) {
                $data = $body['data'];
                $options = array();
                $draft_page_id = 0;
                if (isset($data['options_selected'])) {
                    $options = array(
                        'title' => sanitize_text_field( $data['options_selected']['title'] ),
                        'description' => sanitize_text_field( $data['options_selected']['description'] ),
                    );

                    foreach( $data['options_selected']['plan'] as &$plan ){
                        $plan['name'] = sanitize_text_field( $plan['name'] );
                        $plan['price'] = absint( $plan['price'] );

                    }

                    $options['plan'] = $data['options_selected']['plan'];

                    self::$Setup_Controller::save_optin_data($options);
                }

            }
        }
    }

    public static function handle_set_stripe_mode($request){
        $body = $request->get_json_params();
        $mode = $body['mode'];        
        echo  self::$Stripe::set_stripe_mode($mode);
    }

    public static function handle_get_stripe_mode(){
        echo self::$Stripe::get_stripe_mode();
    }

}