<?php

namespace Paymentpage\includes\controllers;

class AuthController
{

    private const USER_TOKEN_OPTION = "PP_USER_TOKEN";

    public function __construct()
    {}

    /**
     * Generate user token
     * This function will be used to create a token that will be used to match that WP instance with external services
     * TODO: generate a token with more information.
     * IE: JWT could send to services encrypted data into their body like {name, domain, ...}
     */
    public static function generate_user_token()
    {
        $token_gen = rand(99, mt_getrandmax());
        update_option(self::USER_TOKEN_OPTION, $token_gen);
        return $token_gen;
    }

    public static function get_user_token()
    {
        return get_option(self::USER_TOKEN_OPTION);
    }

    public function is_valid_token($token_from_outside)
    {
        $user_token = $this->get_user_token();
        if ($user_token !== $token_from_outside)
            return false;
        return true;
    }
}

