<?php
namespace Paymentpage\includes\controllers;

class DependenciesController
{

    /**
     * Install plugin
     * WARNING: as we are using WP function here.
     * I cant make a clean response in JSON format.
     * Fire this function and when the call return fire another function to get if the plugin was installed.
     */
    public static function install_plugin($plugin, $nonce)
    {
        if (!wp_verify_nonce($nonce, 'wp_rest')) {
            wp_die('You cannot do this');
        }

        $pluginDir = WP_PLUGIN_DIR . '/' . $plugin;
        if (!self::is_plugin_installed($plugin)) {
            try {
                $api = plugins_api('plugin_information', array(
                    'slug' => $plugin
                ));
            } catch (\Throwable $th) {
                return $th;
                throw $th;
            }
            $skin = new \WP_Ajax_Upgrader_Skin();
            $upgrader = new \Plugin_Upgrader($skin);
            $result = $upgrader->install($api->download_link);
            if (is_wp_error($result)) {
                return wp_send_json_error();
            }
            
            return self::activate_dependency($plugin);
        }
    }

    public static function is_plugin_installed($plugin_slug)
    {
        $pluginDir = WP_PLUGIN_DIR . '/' . $plugin_slug;
        if (is_dir($pluginDir)) {
            return true;
        } else {
            return false;
        }
    }

    public static function is_dependency_activated($plugin_slug)
    {
        $pluginPath = $plugin_slug . '/' . $plugin_slug . '.php';
        return is_plugin_active($pluginPath);
    }

    public static function activate_dependency($plugin_slug)
    {
        $pluginDir = WP_PLUGIN_DIR . '/' . $plugin_slug;
        $pluginPath = $pluginDir . '/' . $plugin_slug . '.php';
        if (file_exists($pluginPath)) {
            activate_plugin($pluginPath);
            return true;
        } else {
            // TODO: plugin cannot be activated becouse file doesnt exists
            return false;
        }
    }
}