<?php
namespace Paymentpage\includes\controllers;

class TemplateController
{

    public function __construct()
    {
        $this->Dependency_Controller = new \Paymentpage\includes\controllers\DependenciesController();
        $this->FreemiusController = new \Paymentpage\includes\controllers\FreemiusController();
    }

    /**
     * Get all templates availables and enabled for the plugin author
     * Todo: save templates into plugin options or custom table.
     */
    public function get_templates()
    {
        $user_plan = $this->FreemiusController->get_user_plan();        
        
        $plans_scores = array(
            '9891'=> 0, // Free
			'11498' => 1, // Personal
			'11499' => 2, // Pro
			'11500'=> 3, // Agency
            '11559' => 3, // Lifetime as agency
            '12982' => 1  // Lifetime app sumo as personal
		);
        
        $plan_score = ( $user_plan ?  $plans_scores[$user_plan->id] : 0 );
        $response = wp_remote_get( PAYMENT_PAGE_ADMIN_URL . "?plan_score=$plan_score");
        
        if ( is_wp_error( $response ) ) {            
         return false;
        } else {
            $body = wp_remote_retrieve_body( $response );
            $body_data = json_decode( $body );           
            
            if(!$body_data->success){
                return false;
            }
             
            $templates = json_decode( json_encode($body_data->data->templates), true);
        }

        foreach ($templates as $key => $template) {
            $dependency_name = $template['dependencies'][0]['name'];
            if ($dependency_name === 'gutenberg')
                continue;
            $dependency_installed = $this->Dependency_Controller->is_plugin_installed($dependency_name);
            $dependency_activated = false;
            if ($dependency_installed) {
                $dependency_activated = $this->Dependency_Controller->is_dependency_activated($dependency_name);
            }
            $templates[$key]['dependencies'][0]['installed'] = $dependency_installed;
            $templates[$key]['dependencies'][0]['activated'] = $dependency_activated;
        }
        return $templates;
    }

    private function get_template_selected()
    {}
}