<?php
namespace Paymentpage\includes\elements\Controlls\OpenModal;
/**
 * Pricing emoji one area control.
 *
 * A control for displaying a pricing repeater for plans
 *
 * @since 1.0.0
 */


class OpenModal extends \Elementor\Control_Base_Multiple
{
    
   
    /**
     * Retrieve the control type, in this case `emojionearea`.
     *
     * @since 1.0.0
     * @access public
     *        
     * @return string Control type.
     */
    public function get_type()
    {
        return 'openmodal';
    }

    /**
     *
     * Used to register and enqueue custom scripts and styles used by the emoji one
     * area control.
     *
     * @since 1.0.0
     * @access public
     */
    public function enqueue()
    {
        // Scripts
        wp_register_script('openmodal-control', plugins_url('/assets/js/openmodal-control.js', __FILE__), [
            'jquery',
        ], '1.0.0');
        wp_enqueue_script('openmodal-control');
    }


    // protected function get_default_settings() {
	// 	return [
	// 		'label_block' => true,
	// 		'rows' => 3
	// 	];
	// }




    /**
     * Render emoji one area control output in the editor.
     *
     * Used to generate the control HTML in the editor using Underscore JS
     * template. The variables for the class are available using `data` JS
     * object.
     *
     * @since 1.0.0
     * @access public
     */
    public function content_template()
    {
        ?>
        <div class="elementor-control-field">
        <button onclick="openSettingsModal()">Open settings</button>
		<?php
    }
}