<?php
namespace Paymentpage\includes\elements\PaymentForm\Helpers;
use Elementor\Controls_Manager;
use Elementor\Core\Schemes;

class ElementorHelpers {
  public function __construct($elementor=null){
    $this->elementor = $elementor;
  }

  public function add_font_settings($field_name){
    $this->elementor->add_control( $field_name."_typography", [
        'label' => __('Typography', 'payment-page'),
        'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
        'label_off' => __('Default', 'payment-page'),
        'label_on' => __('Custom', 'payment-page'),
        'return_value' => 'yes'
    ]);
    $this->elementor->start_popover();
    $this->elementor->add_control($field_name."_font_family", [
        'label' => __('Font Family', 'payment-page'),
        'type' => \Elementor\Controls_Manager::FONT,
        'default' => "'Open Sans', sans-serif"
    ]);
    $this->elementor->add_control($field_name."_font_size", [
        'label' => __('Size', 'payment-page'),
        'type' => Controls_Manager::SLIDER,
        'size_units' => [
            'px'
        ],
        'default' => array(
            'unit' => 'px',
            'size' => 12
        ),
        'range' => [
            'px' => [
                'min' => 1,
                'max' => 200
            ],
        ],
        'responsive' => true
    ]);

    $typo_weight_options = array(
        '' => __('Default', 'elementor')
    );

    foreach (array_merge([
        'normal',
        'bold'
    ], range(100, 900, 100)) as $weight) {
        $typo_weight_options[$weight] = ucfirst($weight);
    }

    $this->elementor->add_control($field_name."_font_weight", [
        'label' => _x('Weight', 'Typography Control', 'elementor'),
        'type' => Controls_Manager::SELECT,
        'default' => 'normal',
        'options' => $typo_weight_options
    ]);

    $this->elementor->add_control($field_name."_font_transform", [
        'label' => _x('Transform', 'Typography Control', 'elementor'),
        'type' => Controls_Manager::SELECT,
        'default' => 'none',
        'options' => [
            '' => __('Default', 'elementor'),
            'uppercase' => __('Uppercase', 'elementor'),
            'lowercase' => _x('Lowercase', 'Typography Control', 'elementor'),
            'capitalize' => _x('Capitalize', 'Typography Control', 'elementor'),
            'none' => _x('Normal', 'Typography Control', 'elementor')
        ]
    ]);
    $this->elementor->end_popover();
}
}