<?php 
namespace Paymentpage\includes\elements\PaymentForm\Controll;
use Elementor\Controls_Manager;
use Paymentpage\includes;


class CurrencySelector  {
  

  public function __construct($elementor)
  {
     $this->elementor = $elementor;
     $this->control_name = "switcher";
     $this->elementorHelper = new \Paymentpage\includes\helpers\ElementorHelper();

  }

  public function get_controll(){
    $this->elementor->start_controls_section('currency_selector_section', [
      'label' => 'Currency Selector',
      'tab' => Controls_Manager::TAB_CONTENT
    ]);

    $this->elementor->add_control('currency_selector', [
        'label' => __('Currency selector', 'payment-page'),
        'type' => \Elementor\Controls_Manager::SWITCHER,
        'label_on' => __('On', 'payment-page'),
        'label_off' => __('Off', 'payment-page'),
        'default' => 'yes'
    ]);

    $this->elementor->add_control('currency_symbol', [
        'label' => __('Currency display', 'payment-page'),
        'type' => \Elementor\Controls_Manager::SWITCHER,
        'label_on' => __('Symbol', 'payment-page'),
        'label_off' => __('Text', 'payment-page'),
        'default' => 'no'
    ]);

    $this->elementor->end_controls_section();
  }

  public function styles_settings(){
    $this->elementor->start_controls_section('section_'.$this->control_name.'_style', [
        'label' => __('Switchers', 'payment-page'),
        'tab' => Controls_Manager::TAB_STYLE
    ]);
    $this->switchers_styles();
    $this->elementor->end_controls_section();

  }

  public function switchers_styles(){
    $defaults_font = array(
      'font_family'=> "'Open Sans', sans-serif",
      'font_size'=> array(
          'unit' => 'px',
          'size' => 12
      ),
      'font_weight'=> 'normal',
      'font_transform'=> 'uppercase',
    );
  
    $defaults_border = array(
      'border_color'=>'transparent',
      'border_radius'=> array(
          'unit' => 'px',
          'size' => 0
      ),
      'border_size'=> array(
          'unit' => 'px',
          'size' => 0
      ));

    $this->elementorHelper->add_font_styles($this->elementor, $this->control_name,  'text', $defaults_font);
    $this->elementorHelper->get_background_control($this->elementor, $this->control_name , 'button', 'Button background', 'transparent');
    $this->elementorHelper->get_background_control($this->elementor, $this->control_name , 'button_active', 'Button active background', '#470fc6');
    $this->elementorHelper->get_padding_control($this->elementor, $this->control_name, 'button');
    
    $this->elementorHelper->get_section_title($this->elementor, $this->control_name,  'button','Border');
    $this->elementorHelper->get_border_control($this->elementor, $this->control_name, 'button', $defaults_border);

    $this->elementorHelper->get_section_title($this->elementor, $this->control_name,  'button_active','Active border');
    $this->elementorHelper->get_border_control($this->elementor, $this->control_name, 'button_active', $defaults_border); 
  }
}