<?php 
namespace Paymentpage\includes\elements\PaymentForm\Controll;
require_once (  dirname( dirname(__FILE__)) . '/ElementorHelpers.php' );
use Paymentpage\includes\elements\PaymentForm\Helpers;
use Elementor\Controls_Manager;
use Elementor\Core\Schemes;
use Paymentpage\includes;

class PricingPlansControls  {

   private static $freemius;

  public function __construct($elementor)
  {
    global $payment_page_fs;
    $this->elementor = $elementor;
    $this->helpers = new Helpers\ElementorHelpers($this->elementor);
    $this->elementorHelper = new \Paymentpage\includes\helpers\ElementorHelper();
    $this->control_name = "pricing_plan";
    self::$freemius =  $payment_page_fs; 
     
  }

  public function get_controll(){
    $this->elementor->start_controls_section('plans_section', [
      'label' => __('Pricing plans', 'payment-page'),
      'tab' => \Elementor\Controls_Manager::TAB_CONTENT
    ]);

    $repeater = new \Elementor\Repeater();

    $repeater->add_control('plan_title', [
        'label' => __('Title', 'payment-page'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => __('Plan Title', 'payment-page'),
        'label_block' => true
    ]);

    $prices_description = self::$freemius->is_free_plan() ? 'To accept recurring subscription payments or allow customers to enter their own payment amount, please <a target="_blank" href="'.self::$freemius->get_upgrade_url().'">Upgrade ></a>' : "If left empty, the customer will be able to enter any amount.";

    $repeater->add_control('prices', [
      'type' => 'pricingplans',
      'label_block' => true,
      'description' => $prices_description
    ]);

    $this->elementor->add_control('plans', [
      'label' => __('Plans list', 'payment-page'),
      'type' => \Elementor\Controls_Manager::REPEATER,
      'fields' => $repeater->get_controls(),
      'default' => [
          [
              'plan_title' => __('Your first plan', 'payment-page')
          ],
          [
              'plan_title' => __('Your second plan', 'payment-page')
          ]
      ],
      'title_field' => '{{{ plan_title }}}'
    ]);

    $this->elementor->add_control('pricing_selector_label', [
        'label' => __('Select fields to display:', 'payment-page'),
        'type' => 'pricing_selector_data'
    ]);

    $this->elementor->add_control(
    'pricing_selector_section_label',
      [
        'label' => __( 'Section title', 'payment-page' ),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => __( 'CHOSE YOUR PLAN', 'payment-page' ),
        'placeholder' => __( 'Type your section title', 'payment-page' ),
      ]
    );


    $this->elementor->end_controls_section();
  }

  public function styles_settings(){
    $this->elementor->start_controls_section('section_pricing_plan_styles', [
      'label' => __(' Pricing Plans', 'payment-page'),
      'tab' => Controls_Manager::TAB_STYLE
  ]);
    $this->pricing_plans_styled();
    $this->elementor->end_controls_section();
  }

  private function pricing_plans_styled(){

    $this->elementor->add_control('section_pricing_plan_styles_heading', [
        'label' => __('Border', 'payment-page'),
        'type' => Controls_Manager::HEADING,
        'separator' => 'before'
    ]);
    $field_name = "select";
    $defaults = array(
        'border_color'=> '#cec3e6',
        'border_radius' =>   array(
            'unit' => 'px',
            'size' => 5
        ),
        'border_size'=> array(
            'unit' => 'px',
            'size' => 1
        ),
    );

    $this->elementorHelper->get_border_control($this->elementor, $this->control_name, $field_name, $defaults);
    $this->elementor->add_control('hr_border', [
        'type' => \Elementor\Controls_Manager::DIVIDER
    ]);
    $this->elementorHelper->get_background_control($this->elementor, $this->control_name, 'select', null, '#dedef6' );
   
    $this->elementor->add_control('hr_background', [
        'type' => \Elementor\Controls_Manager::DIVIDER
    ]);

    // Text
    $this->elementorHelper->get_color_control($this->elementor, $this->control_name , 'select_text', null, '#5e3da8');
    $this->elementorHelper->get_color_control($this->elementor, $this->control_name , 'select_dropdown', 'Dropdown icon color', '#470fc6');   
    $this->elementorHelper->get_background_control($this->elementor, $this->control_name , 'select_dropdown', 'Dropdown background' , 'transparent');

    $this->elementor->add_control('pricing_plan_select_dropdown_radius', [
        'label' => __('Dropdown border radius', 'payment-page'),
        'type' => Controls_Manager::SLIDER,
        'size_units' => [
            'px'
        ],
        'default' => array(
            'unit' => 'px',
            'size' => 0
        ),
        'range' => [
            'px' => [
                'min' => 1,
                'max' => 200
            ]
        ],
        'responsive' => true
    ]);


    // Section title
    $this->elementor->add_control('section_pricing_plan_styles_title', [
        'label' => __('Section title', 'payment-page'),
        'type' => Controls_Manager::HEADING,
        'separator' => 'before'
    ]);

    $this->elementor->add_control('pricing_plan_select_title_color', [
        'label' => __('Title color', 'payment-page'),
        'type' => Controls_Manager::COLOR,
        'default' => '#2676f1',
        'scheme' => [
            'type' => Schemes\Color::get_type(),
            'value' => Schemes\Color::COLOR_1
        ]
    ]);


    $defaults = array(
        'font_family'=> "'Open Sans', sans-serif",
        'font_size'=> array(
            'unit' => 'px',
            'size' => 12
        ),
        'font_weight'=> 'normal',
        'font_transform'=> 'none',
    );

    $this->elementorHelper->add_font_styles($this->elementor, $this->control_name , 'select_title',  $defaults);		
}

}