<?php 
namespace Paymentpage\includes\elements\PaymentForm\Controll;
use Elementor\Controls_Manager;
use Elementor\Core\Schemes;
use Paymentpage\includes;

class SubmitButtonControl  {
  

  public function __construct($elementor)
  {
     $this->elementor = $elementor;
     $this->elementorHelper = new \Paymentpage\includes\helpers\ElementorHelper();
     $this->control_name = 'submit';
  }

  public function get_controll()
  {
      $this->elementor->start_controls_section('section_pricing_plans', [
          'label' => __('Submit button', 'payment-page')
      ]);
      $this->elementor->add_control('sorted_text_button', [
          'label' => __('Drag to reorder fields:', 'payment-page'),
          'type' => 'fieldssorted',
          'placeholder' => __('Type your title here', 'payment-page'),
          'label_block' => true
      ]);
      $this->elementor->end_controls_section();
      $this->control_name = 'submit';
  }

  public function styles_settings(){
    $this->elementor->start_controls_section('section_'.$this->control_name.'_style', [
        'label' => __('Submit button', 'payment-page'),
        'tab' => Controls_Manager::TAB_STYLE
    ]);
    $this->submit_button_style();
    $this->elementor->end_controls_section();

  }
  private function submit_button_style() {
      
    $defaults_font = array(
        'font_family'=> "'Open Sans', sans-serif",
        'font_size'=> array(
            'unit' => 'px',
            'size' => 12
        ),
        'font_weight'=> 'normal',
        'font_transform'=> 'uppercase',
    );

    $defaults_border = array(
        'border_color'=>'transparent',
        'border_radius'=> array(
            'unit' => 'px',
            'size' => 4
        ),
        'border_size'=> array(
            'unit' => 'px',
            'size' => 1
        ));
    
    $this->elementorHelper->get_color_control($this->elementor, $this->control_name , 'button_text', null, '#fff');
    $this->elementorHelper->get_background_control($this->elementor, $this->control_name , 'button', null, '#470fc6');
    $this->elementorHelper->add_font_styles($this->elementor, $this->control_name,  'button_text', $defaults_font);
    $this->elementorHelper->get_border_control($this->elementor, $this->control_name, 'button', $defaults_border);
    $this->elementorHelper->get_padding_control($this->elementor, $this->control_name, 'button');
    $this->elementorHelper->get_box_shadow($this->elementor, $this->control_name, 'button');



  }
}