<?php

/*
 * Plugin Name: Payment Page
 * Plugin URI:      https://payment.page
 * Description:     Payment Page is the most powerful way to accept online payments. Connect your payment gateway, choose a template, and get paid!
 * Version:         1.0.3
 * Author:          Gaucho Plugins
 * Author URI:      https://gauchoplugins.com/
 * License:         GPLv3
 * Text Domain:     payment-page
 */
/**
 * Options and dirs as constanst will be easy to find :)
 */
define( 'PAYMENT_PAGE_VERSION', '1.0.3' );
define( 'PAYMENT_PAGE_FILE_', __FILE__ );
define( 'PAYMENT_PAGE_PLUGIN_BASE', plugin_basename( PAYMENT_PAGE_FILE_ ) );
define( 'PAYMENT_PAGE_PATH', plugin_dir_path( PAYMENT_PAGE_FILE_ ) );
define( 'PAYMENT_PAGE_DIR_NAME', basename( __DIR__ ) );
define( 'PAYMENT_PAGE_DATA_PATH', PAYMENT_PAGE_PATH . 'data/' );
define( 'PAYMENT_PAGE_GATEWAYS_OPTION', 'PP_GATEWAYS' );
define( 'PAYMENT_PAGE_GATEWAYS_SELECTED', 'PP_GATEWAYS_SELECTED' );
define( 'PAYMENT_PAGE_SETUP_STEP_NUMBER', 'PP_SETUP_STEP_NUMBER' );
define( 'PAYMENT_PAGE_ADMIN_URL', 'https://payment.page/wp-json/payment-page-admin/v1/get-templates' );

if ( !function_exists( 'payment_page_fs' ) ) {
    // Create a helper function for easy SDK access.
    function payment_page_fs()
    {
        global  $payment_page_fs ;
        
        if ( !isset( $payment_page_fs ) ) {
            // Include Freemius SDK.
            require_once dirname( __FILE__ ) . '/vendor/freemius/wordpress-sdk/start.php';
            $payment_page_fs = fs_dynamic_init( array(
                'id'              => '6031',
                'slug'            => 'payment-page',
                'type'            => 'plugin',
                'public_key'      => 'pk_8cf4a66a0e5efcb9c6c2f3972679d',
                'is_premium'      => false,
                'has_addons'      => false,
                'has_paid_plans'  => true,
                'has_affiliation' => 'selected',
                'menu'            => array(
                'slug'       => 'payment-page',
                'first-path' => 'admin.php?page=payment-page',
            ),
                'is_live'         => true,
            ) );
        }
        
        return $payment_page_fs;
    }
    
    // Init Freemius.
    payment_page_fs();
    // Signal that SDK was initiated.
    do_action( 'payment_page_fs_loaded' );
    
    if ( $payment_page_fs ) {
        function my_fs_custom_icon()
        {
            return dirname( __FILE__ ) . '/public/assets/img/icon.jpg';
        }
        
        payment_page_fs()->add_filter( 'plugin_icon', 'my_fs_custom_icon' );
        require_once ABSPATH . 'wp-admin/includes/plugin-install.php';
        require_once ABSPATH . 'wp-admin/includes/plugin.php';
        require_once ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';
        require_once ABSPATH . 'wp-admin/includes/class-wp-ajax-upgrader-skin.php';
        require_once ABSPATH . 'wp-admin/includes/file.php';
        require_once plugin_dir_path( __FILE__ ) . 'vendor/autoload.php';
        Paymentpage\includes\Menu::init();
        // We add the menu here
        $main = new Paymentpage\includes\Main();
        $main->run();
    }

}
